<script>
  import { json } from "d3-fetch";
  import { onMount } from 'svelte';
  

  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  let week_1_elec = "";
  let week_1_gas = "";

  let week_2_elec = "";
  let week_2_gas = "";

  let week_3_elec = "";
  let week_3_gas = "";

  let week_4_elec = "";
  let week_4_gas = "";

  let week_5_elec = "";
  let week_5_gas = "";

  onMount(async () => {
    let dat = await json(`/data/hourly_electricity_vs_gas_december.json`);
    for (let i in dat) {
      // Making a string for a polygon for each week
      if ((dat[i]["city"] == "Chicago") && (dat[i]["week"] == 48)) {
        week_1_elec = week_1_elec + " " + i + "," + (-Math.abs(dat[i]["total_electrity"])/20).toFixed(1);
        week_1_gas = week_1_gas + " " + i + "," + (Math.abs(dat[i]["total_gas"])/100 - 10).toFixed(1);
      }
      if ((dat[i]["city"] == "Chicago") && (dat[i]["week"] == 49)) {
        week_2_elec = week_2_elec + " " + i + "," + (-Math.abs(dat[i]["total_electrity"])/20).toFixed(1);
        week_2_gas = week_2_gas + " " + i + "," + (Math.abs(dat[i]["total_gas"])/100 - 10).toFixed(1);
      }
      if ((dat[i]["city"] == "Chicago") && (dat[i]["week"] == 50)) {
        week_3_elec = week_3_elec + " " + i + "," + (-Math.abs(dat[i]["total_electrity"])/20).toFixed(1);
        week_3_gas = week_3_gas + " " + i + "," + (Math.abs(dat[i]["total_gas"])/100 - 10).toFixed(1);
      }
      if ((dat[i]["city"] == "Chicago") && (dat[i]["week"] == 51)) {
        week_4_elec = week_4_elec + " " + i + "," + (-Math.abs(dat[i]["total_electrity"])/20).toFixed(1);
        week_4_gas = week_4_gas + " " + i + "," + (Math.abs(dat[i]["total_gas"])/100 - 10).toFixed(1);
      }
      if ((dat[i]["city"] == "Chicago") && (dat[i]["week"] == 52)) {
        week_5_elec = week_5_elec + " " + (i-200)  + "," + (-Math.abs(dat[i]["total_electrity"])/20).toFixed(1);
        week_5_gas = week_5_gas + " " + (i-200)  + "," + (Math.abs(dat[i]["total_gas"])/100 - 10).toFixed(1);
      }
    }
  });


</script>

<svg {width} {height}>
  <!-- Plotting steam -->
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    <line x1={width/2 - 10} x2={width/2 - 10} y1="125" y2="500" class="ax_line"/>
  </g>

  <!-- Plotting first leaf -->
  <g transform="translate({margin.left} {margin.top}) rotate(-30 1000 -230)">
    <polygon points={week_1_elec} class="blue_leaf"/>
    <polygon points={week_1_gas} class="orange_leaf"/>
  </g>
  <text x=420 y=380 class="small"> Week 48 </text>

  <!-- Plotting second leaf -->
  <g transform="translate({margin.left} {margin.top}) rotate(30 -450 -10)">
    <polygon points={week_2_elec} class="blue_leaf"/>
    <polygon points={week_2_gas} class="orange_leaf"/>
  </g>
  <text x=30 y=300 class="small"> Week 49 </text>

  <!-- Plotting third leaf -->
  <g transform="translate({margin.left} {margin.top}) rotate(-30 880 310)">
    <polygon points={week_3_elec} class="blue_leaf"/>
    <polygon points={week_3_gas} class="orange_leaf"/>
  </g>
  <text x=420 y=220 class="small"> Week 50 </text>

  <!-- Plotting fourth leaf -->
  <g transform="translate({margin.left} {margin.top}) rotate(30 50 -720)">
    <polygon points={week_4_elec} class="blue_leaf"/>
    <polygon points={week_4_gas} class="orange_leaf"/>
  </g>
  <text x=30 y=120 class="small"> Week 51 </text>

  <!-- Plotting fifth leaf -->
  <g transform="translate({margin.left} {margin.top}) rotate(-30 600 490)">
    <polygon points={week_5_elec} class="blue_leaf"/>
    <polygon points={week_5_gas} class="orange_leaf"/>
  </g>
  <text x=330 y=80 class="small"> Week 52 </text>

  <!-- title -->
  <text x={width/2 - 55} y=540 class="large"> Baltimore </text>
  <text x={width/2 - 70} y=580 class="medium"> (December 2014) </text>

</svg>

<style>
  
  .ax_line {
    stroke: rgb(0, 0, 0);
    stroke-width: 2;
  }
  .blue_leaf {
    fill:blue;
    stroke:blue;
    stroke-width:1
  }
  .orange_leaf {
    fill:orange;
    stroke:orange;
    stroke-width:2
  }
  .small {
    font: italic 12px sans-serif;
    fill: black;
  }
  .large {
    font: 40px Brush Script MT;
  }
  .medium {
    font: 30px Brush Script MT;
  }
</style>
